# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
import tools.config
import netsvc
import sql_db

class hrself_universe(osv.osv):
    _inherit = "hrself.universe"                                                                                                                  

    _columns = {
        # FIXME commented readonly to easy data insertion
        'db': fields.char('Database', size=48, required=True,),# readonly=True),
    }

hrself_universe()

class PortalException(Exception): pass

class Portal(netsvc.ExportService):
    def __init__(self, name="portal"):
        netsvc.ExportService.__init__(self, name)
        self.joinGroup("web-services")

    def dispatch(self, method, auth, params):
        if method in [ 'get_db_for_universe' ]:
            # No security check for these methods
            pass
        else:
            raise KeyError("Method not found: %s" % method)
        fn = getattr(self, method)
        return fn(*params)

    def get_db_for_universe(self, universe):
        universe_db = ""
        if 'central_db_name' not in tools.config.options:
            self._logger.warning("No central database specified in config file.")
        else:
            db = sql_db.db_connect(tools.config['central_db_name'])
            cr = db.cursor()
            try:
                query = "SELECT db FROM hrself_universe WHERE name=%s"
                params = (universe,)
                cr.execute(query, params)
                res = cr.fetchone()
                universe_db = res and str(res[0])
            except Exception, e: # TODO: catched exception please
                raise PortalException(e)
            finally:
                cr.close()
        return universe_db

Portal()
