## -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv

class hrself_synchro(osv.osv_memory):
    """HRSelf Synchronization """

    _inherit = 'base.synchro'

    def _default_server_url(self, cr, uid, context=None):
        """Default server URL."""
        ids = self.pool.get('base.synchro.server').search(cr, uid, [], context=None)
        if len(ids) == 1:
            return ids[0]
        else:
            return False

    _defaults = {
        'server_url': _default_server_url,
    }

    def relation_transform(self, cr, uid, pool_src, pool_dest, object, id, action, context=None):
        result = super(hrself_synchro, self).relation_transform(cr, uid, pool_src, pool_dest, object, id, action, context=context)
        if not result and (hasattr(pool_src.get(object), 'synchro_get') and hasattr(pool_dest.get(object), 'synchro_search')):
            values = pool_src.get(object).synchro_get(cr, uid, [id])[0][1]
            res = pool_dest.get(object).synchro_search(cr, uid, values)
            if res:
                result = res[0][0]
            else:
                # LOG this in the report, better message.
                print self.report.append('WARNING: Record "%s" on relation %s still not found, set to null.' % (values, object))
        return result

hrself_synchro()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
